;*************************************************************************
; FILE ..........: FMS_cbl.PIC
; AUTHOR ........: Vitaly Puzrin
; DESCRIPTION ...: Firmware for FMR interface cable
; NOTES .........:
; COPYRIGHT .....: Vitaly Puzrin, 2000    http://www.rcdesign.ru
; HISTORY .......: DATE		COMMENT
;                  ---------------------------------------------------
;                  25.11.2000	First version.
;*************************************************************************
;  =4,0 

        LIST            p=12F675
        #INCLUDE        <p12F675.inc>   

 __CONFIG  _INTRC_OSC_NOCLKOUT & _BODEN_ON & _CP_OFF & _CPD_OFF & _PWRTE_ON & _WDT_ON  & _MCLRE_OFF
 
       errorlevel      +302    ;    
;===================================================
#DEFINE BANC0 BCF STATUS,RP0
#DEFINE BANC1 BSF STATUS,RP0
#define		TxBit	GPIO, 0		;  
#define		RAM_START	H'20'



BAUD_1  	equ	D'15'		; 3 + 5 +3X = CLKOUT/Baud
BAUD_X  	equ	D'12'		; 11 + 5 + 3X = CLKOUT/Baud

;------------------------------------
;  
;
	CBLOCK	RAM_START
		PktCnt		;    
		TxData		;   
		BitCnt		;     
		TimeCnt		;   
		DelCnt		;  

		PktStart	;   
	ENDC

	org	0

;------------------------------------
;   (HARDWARE  WDT)
;    FF
;
Reset:
                             ;  
          BANC0                   ;.  0
          CLRWDT                  ; WDT  
          CLRF     GPIO           ; GPIO
          MOVLW    B'00000111'    ; ,
          MOVWF    CMCON
          CLRF     ADCON0         ; 
          CALL     3FFh           ; 
          BANC1                   ;.  1
          MOVWF    OSCCAL^80H
          CLRF     ANSEL^80H      ;GPIO-  -
          MOVLW    B'00111101'    ;..,. WDT,.=128:
          MOVWF    OPTION_REG^80H ;
          MOVLW    B'00111110'    ; GP2,GP4,GP5  ,GP3,GP0,GP1-
          MOVWF    TRISIO^80H
          MOVLW    B'00000110'
          MOVWF    WPU
          CLRF     PIE1
          CLRF    IOCB
          CLRF     VRCON^80H
          BANC0
	bsf	TxBit

	clrwdt			;   ,   
				;     

	clrf	TMR0		;    

	clrf	PktCnt
	goto	send_pkt	;   .
				;


;------------------------------------
;------------------------------------
;   .
; (!)    
;      .
;    
;   .
;
wait_first_front:
	movf	TMR0, W			;     
	btfsc	STATUS, Z
	goto	wait_first_front
;
	nop		;   
	nop		;   
	nop		;
	nop		;
	nop		;
	nop		;

;------------------------------------
;    4- .
;     ,
;    FF
;
measure_channel:
;
	clrf	TMR0
	clrwdt

	movlw	D'143'				;   715 ,
	movwf	DelCnt
DelLp:
	nop
	nop
	decfsz	DelCnt, F
	goto	DelLp

	nop
	nop

;
;     
;
	movlw	0FFh			; 
	movwf	TimeCnt			;  
wait_front_loop:
	movf	TMR0, W			;   -
	btfss	STATUS, Z		; 7 .
	goto	save_measurement
	decfsz	TimeCnt, F		;    
	goto	wait_front_loop		; ( ) 
					;   
					;   
	goto	send_pkt

;------------------------------------
;   
;  
;
save_measurement:
	clrf	TMR0
	comf	TimeCnt, W		; (!)  ,
	movwf	INDF			;      
	incf	FSR, F
	incf	PktCnt,F
	goto	measure_channel

;------------------------------------
; , -.  
;   
;
send_pkt:
	movlw	PktStart
	movwf	FSR

	clrf	TxData
	decf	TxData,F
	call	tx_byte			;   

	movlw	PktStart
	movwf	FSR

	movf	PktCnt, W
	btfsc	STATUS, Z
	goto	skip_data

pkt_loop:
	movf	INDF, W
	movwf	TxData
	call    tx_byte
	incf	FSR, F
	decfsz	PktCnt, F
	goto	pkt_loop

skip_data:

	clrf	PktCnt
	movlw	PktStart                ; (  )
	movwf	FSR

	clrf	TMR0			;  
					;  
	goto	wait_first_front	;   
					;  

;------------------------------------
;------------------------------------
;  1   
; .  19200 .
;   - 81N
;
tx_byte:
	movlw	8
	movwf	BitCnt
;
	bcf	TxBit			;  -
	call	Delay1
tx_next_bit:
	bcf	STATUS,C
;
	rrf	TxData,F
;
	btfsc	STATUS,C
	bsf	TxBit
	btfss	STATUS,C
	bcf	TxBit
	call	DelayX
	decfsz	BitCnt,F
	goto	tx_next_bit
	bsf	TxBit		; Send Stop Bit
	call    Delay1
;
	retlw	0
;
;     
;
DelayX  movlw   BAUD_X
	goto    save

Delay1  movlw   BAUD_1            ; 52 uS   19200 
	goto    save

save    movwf   DelCnt
redo_1  decfsz  DelCnt,F
	goto    redo_1

	retlw   0
        FILL (GOTO Reset),(3FFh-$)
	end
